(define-module (ui selinux-seusers ajax)
    :use-module (alterator ajax)
    :use-module (alterator algo)
    :use-module (alterator woo)
    :export (on-load))

(define (do-users)
  (let ((data (woo-read-first "/selinux-seusers" 'users (form-value "users"))))
  (form-update-value-list '("maxlevel" "minlevel" "roles" "categories") data)
  )
  (do-list-category)
)

(define (ui-new_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-seusers/new_user"
	     (form-value-list))))
  (ui-init)
  )

(define (ui-change_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-seusers/change_user" 'users (form-value "users")
	     (form-value-list))))
  (do-users)
  )

(define (ui-delete_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-seusers/delete_user" 'language (form-value "language")
	     (form-value-list))))
  (ui-init)
  (do-users)
  )

(define (ui-init)
   (catch/message
     (lambda()
       (form-update-enum "users" (woo-list "/selinux-seusers/list_seusers"))
       (form-update-enum "roles" (woo-list "/selinux-seusers/list_role"))
     )
   )
)

(define (do-list-category)
  (let ((data (woo-read-first "/selinux-seusers" 'categories (form-value "categories")
			      			'users (form-value "users"))))
    (form-update-enum "category" (woo-list "/selinux-seusers/list_category" 'users (form-value "users")
                                                                          'categories (form-value "categories")))
    (form-update-value-list '("category") data)
  )
)

(define (on-load)
  (ui-init)
  (form-update-enum "categories" (woo-list "/selinux-seusers/list_all_categories"))
  (form-update-enum "minlevel" (woo-list "/selinux-seusers/list_sensitivity"))
  (form-update-enum "maxlevel" (woo-list "/selinux-seusers/list_sensitivity"))
  (form-bind "users" "change" do-users)
  (form-bind "categories" "change" do-list-category)
  (form-bind "new_user" "click" ui-new_user)
  (form-bind "change_user" "click" ui-change_user)
  (form-bind "delete_user" "click" ui-delete_user)
)
