(define-module (ui selinux-users ajax)
    :use-module (alterator ajax)
    :use-module (alterator algo)
    :use-module (alterator woo)
    :export (on-load))

(define (do-users)
  (let ((data (woo-read-first "/selinux-users" 'users (form-value "users"))))
    (form-update-value-list '("seuser") data)
  (form-update-enum "categories" (woo-list "/selinux-users/list_all_categories" 'seuser (form-value "seuser")))
  (form-update-enum "minlevel" (woo-list "/selinux-users/list_sensitivity" 'seuser (form-value "seuser")))
  (form-update-enum "maxlevel" (woo-list "/selinux-users/list_sensitivity" 'seuser (form-value "seuser")))
  (form-update-value-list '("maxlevel" "minlevel" "categories") data)
  )
  (do-list-category)
)

(define (do-seusers)
  (form-update-enum "categories" (woo-list "/selinux-users/list_all_categories" 'seuser (form-value "seuser")))
  (let ((data (woo-read-first "/selinux-users" 'seuser (form-value "seuser")
			      			'users (form-value "users"))))
    (form-update-value-list '("maxlevel" "minlevel" "category" "categories") data)
    (form-update-enum "category" (woo-list "/selinux-users/list_category" 'users (form-value "users")
					   				  'seuser (form-value "seuser")))
    (form-update-enum "minlevel" (woo-list "/selinux-users/list_sensitivity" 'seuser (form-value "seuser")))
    (form-update-enum "maxlevel" (woo-list "/selinux-users/list_sensitivity" 'seuser (form-value "seuser")))
  )
  (do-list-category)
)

(define (do-list-category)
  (let ((data (woo-read-first "/selinux-users" 'categories (form-value "categories")
					       'users (form-value "users")
					       'seuser (form-value "seuser"))))
    (form-update-enum "category" (woo-list "/selinux-users/list_category" 'users (form-value "users")
					 				  'seuser (form-value "seuser")
									  'categories (form-value "categories")))
    (form-update-value-list '("category") data)
  )
)


(define (ui-new_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-users/new_user" 'seuser (form-value "seuser")
	     (form-value-list))))
  (ui-init)
  )

(define (ui-change_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-users/change_user" 'seuser (form-value "seuser")
	     (form-value-list))))
  (do-users)
  )

(define (ui-delete_user)
  (catch/message
    (lambda()
      (apply woo-write "/selinux-users/delete_user"
	     (form-value-list))))
  (ui-init)
  (do-users)
  (ui-init)
  )

(define (ui-init)
   (catch/message
     (lambda()
       (form-update-enum "users" (woo-list "/selinux-users/list_users"))
       (form-update-enum "seuser" (woo-list "/selinux-users/list_seuser"))
       (form-update-enum "all_users" (woo-list "/selinux-users/list_allusers"))
       (form-update-enum "minlevel" (woo-list "/selinux-users/list_sensitivity"))
       (form-update-enum "maxlevel" (woo-list "/selinux-users/list_sensitivity"))
     )
   )
)


(define (on-load)
  (ui-init)
  (form-bind "users" "change" do-users)
  (form-bind "seuser" "change" do-seusers)
  (form-bind "categories" "change" do-list-category)
  (form-bind "new_user" "click" ui-new_user)
  (form-bind "change_user" "click" ui-change_user)
  (form-bind "delete_user" "click" ui-delete_user)
)
